/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: Rule.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_RULE_HPP_
#define _TOPS_RULE_HPP_

#include "tops/ActionPart.hpp"
#include "tops/ConditionPart.hpp"

#include "tops/common/Printable.hpp"

#include <string>

#include <boost/shared_ptr.hpp>

namespace tops {

	class Rule;
	typedef boost::shared_ptr<Rule> RulePtr;

	/**
	 * ルールです。
	 *
	 * @author トゥイー
	 */
	class Rule : public Printable {
	private:
		/**
		 * 名前です。
		 */
		std::string m_name;

		/**
		 * 条件部です。
		 */
		ConditionPart m_lhs;

		/**
		 * 行動部です。
		 */
		ActionPart m_rhs;

	public:
		/**
		 * ルールを構築します。
		 *
		 * @param name 規則名を指定します。
		 * @param lhs 条件部を指定します。
		 * @param rhs 行動部を指定します。
		 */
		Rule(const std::string& name, const ConditionPart& lhs, const ActionPart& rhs) :
		m_name(name), m_lhs(lhs), m_rhs(rhs) {
		}

	public:
		/**
		 * 名前を取得します。
		 */
		const std::string& getName() const {
			return m_name;
		}

		/**
		 * 条件部を取得します。
		 */
		ConditionPart& getConditionPart() {
			return m_lhs;
		}

		ActionPart& getActionPart() {
			return m_rhs;
		}

	public:
		/**
		 * ストリームに出力します。
		 */
		void print(std::ostream& stream) const;
	};

}  // namespace tops

#endif
